<?php
/*
  QTpro
  Version 7.4.9 Phoenix

  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2021 Rainer Schmied

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

class hook_admin_catalog_catQtPro {

  public $version = '7.4.9';

  function listen_postAction() {
    global $product_investigation;

    if (isset($product_investigation['any_problems'])) {
      $GLOBALS['messageStack']->add('<strong>Warning: </strong>'. qtpro_doctor_formulate_product_investigation($product_investigation, 'short_suggestion'), 'warning');
    }
  }

  function listen_updateProductAction() {
    global $product_investigation, $db;

    $stockaction = $_POST['action'] ?? null;
    $stockquantity = isset($_POST['stockquantity'])? $_POST['stockquantity'] : '';
    if ( !empty($stockaction) && $stockaction == 'Add' && $stockquantity != '' ) {
      $inputok = true;
      if (!(is_numeric($_GET['pID']) && ($_GET['pID']==(int)$_GET['pID']))) $inputok = false;
      foreach($_POST as $v1 => $v2) {
        
        
        if (preg_match('/^option(\d+)$/',$v1,$m1)) {
          if (is_numeric($v2) && ($v2==(int)$v2)) $val_array[] = $m1[1].'-'.$v2;
          else $inputok = false;
        }
      }

      if ( !(is_numeric($stockquantity) && ($stockquantity == (int)$stockquantity))) $inputok = false;
      if (($inputok)) {
        sort($val_array, SORT_NUMERIC);
        $val = Text::prepare(join(',', $val_array));
        $q = $db->query(sprintf(<<<'EOSQL'
SELECT products_stock_id AS stock_id
  FROM products_stock
  WHERE products_id = %s
    AND products_stock_attributes = '%s'
  ORDER BY products_stock_attributes
EOSQL
        , (int)$_GET['pID'], $db->escape($val)));

        if (mysqli_num_rows($q) > 0) {
          $stock_item = $q->fetch_assoc();
          $stock_id = Text::prepare($stock_item['stock_id']);
          if ($stockquantity == intval($stockquantity)) {
            $db->query(sprintf(<<<'EOSQL'
UPDATE products_stock
  SET products_stock_quantity = %s
  WHERE products_stock_id = '%s'
EOSQL
          , (int)$stockquantity, $db->escape($stock_id)));

          } else {
            $db->query(sprintf(<<<'EOSQL'
DELETE FROM products_stock
  WHERE products_stock_id = '%s'
EOSQL
            , $db->escape($stock_id)));

          }
        } else {
          $db->query(sprintf(<<<'EOSQL'
INSERT INTO products_stock
VALUES ('0','%s', '%s', '%s')
EOSQL
          , (int)$_GET['pID'], $db->escape($val), (int)$stockquantity));

        }
        $q = $db->query(sprintf(<<<'EOSQL'
SELECT SUM(products_stock_quantity) AS summa
  FROM products_stock
    WHERE products_id = %s
      AND products_stock_quantity > 0
EOSQL
        , (int)$_GET['pID']));

        $list = $q->fetch_assoc();
        $summa = (int)(empty($list['summa'])) ? 0 : $list['summa'];
        $db->query(sprintf(<<<'EOSQL'
UPDATE products
  SET products_quantity = %s
  WHERE products_id = %s
EOSQL
        , $summa, (int)$_GET['pID']));

        if (($summa<1) && (STOCK_ALLOW_CHECKOUT == 'false')) {
          $db->query(sprintf(<<<'EOSQL'
UPDATE products
  SET products_status = '0'
  WHERE products_id = %s 
EOSQL
          , (int)$_GET['pID']));
          $_POST['products_quantity'] = $summa;
        }
      }
      Href::redirect($GLOBALS['Admin']->link('catalog.php', ['cPath' => $GLOBALS['cPath'], 'pID' => $GLOBALS['products_id'], 'action' => 'new_product', 'stock_updated' => 'true']));
    }
  }



  function listen_productTab() {
    global $product_investigation, $stockquantity, $db;

    if ( 'new_product' === $GLOBALS['action'] && isset($product_investigation) && ($product_investigation['has_tracked_options'] || $product_investigation['stock_entries_count'] > 0) ) {


      $flag = null;
      $q = $db->query(sprintf(<<<'EOSQL'
SELECT pd.products_name, po.products_options_name AS _option, pa.options_id AS _option_id, pov.products_options_values_name AS _value, pa.options_values_id AS _value_id
  FROM products_description pd, products_attributes pa, products_options po, products_options_values pov
  WHERE pa.products_id = pd.products_id
    AND pa.products_id = %1$s
    AND pa.options_id = po.products_options_id
    AND pa.options_values_id = pov.products_options_values_id
    AND pd.language_id = %2$s
    AND pov.language_id = %2$s
    AND po.products_options_track_stock = 1
    AND po.language_id = %2$s
  ORDER BY pa.options_id, pa.options_values_id
EOSQL
      , (int)$_GET['pID'], (int)$GLOBALS['languages_id']));

      $db_quantity = null;
      if ( mysqli_num_rows($q) > 0 ) {
        $flag = 1;
        while ( $list = $q->fetch_assoc() ) {
          $options[$list['_option_id']][] = array($list['_value'], $list['_value_id']);
          $option_names[$list['_option_id']] = $list['_option'];
          $product_name = $list['products_name'];
        }
      }

      $product_investigation = qtpro_doctor_investigate_product($_GET['pID']);
      ?>
      <div class="tab-pane fade" id="section_attributes_stock" role="tabpanel">
        <div class="row">
          <div class="col-sm-6">
            <table class="table table-striped w-100 text-center">
              <?php
              echo '<thead class="thead-dark">';
              echo '  <tr>';
                  $title_num = 1;
                  if ($flag) {
                    foreach($options as $k => $v) {
                      echo '<th>' . $option_names[$k] . '</th>';
                      $title[$title_num] = $k;
                    }
                    echo '        <th>' . TABLE_HEADING_QUANTITY . '</th>';
                    echo '  </tr>';
                    echo '</thead>';
                    echo '<tbody>';
                    //sorting below goes by name rather than products_stock_attributes. Much easier to have it all sorted alphabetically
                    $q = $db->query(sprintf(<<<'EOSQL'
SELECT ps.*, pov.*
  FROM products_stock ps, products_options_values pov
  WHERE ps.products_id = %s
    AND pov.products_options_values_id = substring_index(ps.products_stock_attributes, '-', -1)
  ORDER BY pov.products_options_values_name ASC
EOSQL
                    , (int)$_GET['pID']));

                    $test_string = '';
                    while ( $rec = $q->fetch_assoc() ) {
                      $val_array = explode(',', $rec['products_stock_attributes']);

                      if ( strpos($test_string, $rec['products_stock_attributes'] . ';') === false ) {
						echo '<tr>';
                        foreach($val_array as $val) {
                          if (preg_match('/^(\d+)-(\d+)$/',$val,$m1)) {
                            $values = $db->query("SELECT products_options_values_name FROM products_options_values WHERE products_options_values_id = " . (int)$m1['2'] . " AND language_id = " . (int)$_SESSION['languages_id']);
                            $values_values = $values->fetch_assoc();
                            echo '<td>' . $values_values['products_options_values_name'] . '</td>';
                          } else {
                            echo '<td></td>';
                          }
                        }
                        for($i = 0;$i<sizeof($options)-sizeof($val_array);$i++) {
                            echo '<td></td>';
                        }
                        echo '<td>' . $rec['products_stock_quantity'] . '</td></tr>';
                        $test_string .= $rec['products_stock_attributes'] . ';';
                      }
                    }
                    echo '<tr class="bg-dark">';
                    reset($options);
                    foreach($options as $k => $v) {
                      $options_array = null;
                      foreach($v as $v1) {
                        $options_array[] = ['id' => $v1['1'], 'text' => $v1['0']];
                      }
                      echo '<td>' . new Select('option' . $k, $options_array) . '</td>';
                      
                    }
                  }
                  echo '<td>';
                  echo '  <div class="input-group">';
                  echo      new Input('stockquantity', ['class' => 'form-control', 'style' => 'width:25px;']);
                  echo      new Input('product_id', ['value' => $_GET['pID']], 'hidden');
                  echo      new Input('action', ['value' => 'Add'], 'hidden');
                  echo      new Input('products_quantity', ['value' => $GLOBALS['product']->get('in_stock')], 'hidden');
                  echo '    <div class="input-group-append">';
                  echo        new Button(BUTTON_ADD, 'fas fa-update', 'btn-success');
                  echo '    </div>';
                  echo '  </div>';
                  echo '</td>';
                  ?>
                </tr>
              </tbody>
            </table>

            <?= new Button(TEXT_LINK_LOW_STOCK_REPORT, 'fas fa-info-circle', 'btn-info btn-block', [], $GLOBALS['Admin']->link('stats_low_stock_attrib.php')) ?>

          </div>
          <div class="col-sm-6">
            <h3><b><?= TABLE_HEADING_QTPO_DOCTOR ?></b></h3>

            <?= qtpro_doctor_formulate_product_investigation($product_investigation, 'detailed') ?>

          </div>
        </div>
      </div>
<?php

      $tab_title = addslashes(HOOK_SWQTPRO_TAB_TITLE);

      $output = <<<EOD
<script>
$(function() {
$('#productTabs ul').append('<li class="nav-item"><a class="nav-link" data-toggle="tab" href="#section_attributes_stock" role="tab"><i class="fas fa-filter fa-fw mr-1"></i>{$tab_title}</a></li>');
});
</script>
EOD;
      return $output;
    }
  }

  function listen_injectSiteEnd() {
    global $product_investigation;

    if ( ('new_product' === $GLOBALS['action'] || 'new_product&stock_updated' === $GLOBALS['action']) && isset($product_investigation) && ($product_investigation['has_tracked_options'] || $product_investigation['stock_entries_count'] > 0) ) {

      $output = <<<EOD
<script>

$(function() {
$('#pQty').attr('disabled', true);
});
</script>
EOD;

    if ( isset($_GET['stock_updated']) && $_GET['stock_updated'] == 'true' ) {

      $output .= <<<EOD
<script>

$(function() {
$('#productTabs a[href="#section_attributes_stock"]').tab('show') // Select tab by name
$('#section_attributes_stock').tab('show')
});
</script>
EOD;
    }

    return $output;

    }
  }

}
