<?php
/*
  QTpro
  Version 7.4.8 Phoenix

  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2021 Rainer Schmied

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

class hook_admin_siteWide_swQtPro {

  public $version = '7.4.0';

  function __construct() {

    require('includes/functions/qtpro_functions.php');

  }

  function listen_injectSiteStart() {
    global $product_investigation, $products_attributes_filename, $Admin;

    if ( 'catalog.php' === Request::get_page() ) {

      if ( !defined('PI_QTPRO_OPTIONS_STATUS') && !defined('MODULE_CONTENT_PI_QTPRO_OPTIONS_STATUS') ) {
        $GLOBALS['messageStack']->add(QTPRO_OPTIONS_WARNING . '<br>
              <a href="modules_content.php?module=cm_pi_qtpro_options&action=install">' . QTPRO_OPTIONS_INSTALL_NOW . '</a>', 'warning');
      }
      if (!file_exists(DIR_FS_CATALOG . 'templates/' . TEMPLATE_SELECTION . '/includes/hooks/shop/siteWide/qtPro.php')) {
        $GLOBALS['messageStack']->add(QTPRO_ERROR_SHOP_HOOK, 'warning');
      }

      //Create the product investigation for this product that are used in this page.
      $product_investigation = (isset($_GET['pID']))? qtpro_doctor_investigate_product($_GET['pID']) : null;
      $qtpro_sick_count = qtpro_sick_product_count();
      if ($qtpro_sick_count != 0) {
        $GLOBALS['messageStack']->add(sprintf(HOOK_SWQTPRO_WARNING, $qtpro_sick_count, $Admin->link('qtprodoctor.php')), 'error');
      }
    } elseif ( 'products_attributes.php' === Request::get_page() ) {

      $qtpro_sick_count = qtpro_sick_product_count();
      if ($qtpro_sick_count != 0) {
        $GLOBALS['messageStack']->add(sprintf(HOOK_SWQTPRO_WARNING, $qtpro_sick_count, $Admin->link('qtprodoctor.php')), 'error');
      }

      $products_attributes_filename = null;

    }

  }

}
