<?php
/*
  $Id$

  QTpro
  Version 7.4.5 Phoenix

  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2021 Rainer Schmied

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

  class cm_pi_qtpro_options extends abstract_executable_module {

    const CONFIG_KEY_BASE = 'MODULE_CONTENT_PI_QTPRO_OPTIONS_';

    public function __construct() {
      parent::__construct(__FILE__);
      $this->description .= '<div class="secWarning"><a target="_blank" href="https://www.oscaddons.com/en/commercial-add-ons/qtpro-update-product-price-p-56.html"><u>GET QTpro Update Product Price</u></a><br>
                            - Dynamically update the shown Product Price depending on the selected options.<br>
                              <a target="_blank" href="https://www.oscaddons.com"><u>www.oscaddons.com</u></a>
                            </div>';

      if (!file_exists(DIR_FS_CATALOG . 'templates/' . TEMPLATE_SELECTION . '/includes/hooks/shop/siteWide/qtPro.php')) {
        $this->description = '<div class="secWarning">' . MODULE_CONTENT_PI_QTPRO_OPTIONS_ERROR_HOOK . '</div>' . $this->description;
        $this->enabled = false;
      }

    }

    function execute() {

      $content_width = (int)MODULE_CONTENT_PI_QTPRO_OPTIONS_CONTENT_WIDTH;

      if ([] !== $GLOBALS['product']->get('attributes')) {
        $qtpro_options = $GLOBALS['pad']->draw();

        $tpl_data = [ 'group' => $this->group, 'file' => __FILE__ ];
        include 'includes/modules/content/cm_template.php';
      }
    }

    protected function get_parameters() {
      return [
        'MODULE_CONTENT_PI_QTPRO_OPTIONS_VERSION_INSTALLED' => [
          'title' => 'Current Version',
          'value' => '7.4.5. Phoenix',
          'desc' => 'Version info. It is read only',
          'set_func' => 'cm_pi_qtpro_options::readonly(',
        ],
        'MODULE_CONTENT_PI_QTPRO_OPTIONS_STATUS' => [
          'title' => 'Enable QTPRO Options Module',
          'value' => 'True',
          'desc' => 'Should this module be shown on the product info page?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_PI_QTPRO_OPTIONS_CONTENT_WIDTH' => [
          'title' => 'Content Width',
          'value' => '6',
          'desc' => 'What width container should the content be shown in?',
          'set_func' => "Config::select_one(['12', '11', '10', '9', '8', '7', '6', '5', '4', '3', '2', '1'], ",
        ],
        'MODULE_CONTENT_PI_QTPRO_OPTIONS_REMOVE_DATA' => [
          'title' => 'Uninstall Removes Database entries',
          'value' => 'False',
          'desc' => 'Do you want to remove the QT Pro database entries when uninstall the module?<br>All attribute quantities and other QT Pro database entries will be lost. Use only if you just installed QT Pro for testing purpose and you are sure not to use QT Pro any more.',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_PI_QTPRO_OPTIONS_PLUGIN' => [
          'title' => 'Product Info Attribute Display Plugin',
          'value' => 'multiple_dropdowns',
          'desc' => 'The plugin used for displaying attributes on the product information page.',
          'set_func' => "Config::select_one(['multiple_dropdowns', 'sequenced_dropdowns', 'single_dropdown', 'single_radioset'], ",
        ],
        'MODULE_CONTENT_PI_QTPRO_OPTIONS_SHOW_OUT_OF_STOCK' => [
          'title' => 'Show Out of Stock Attributes',
          'value' => 'True',
          'desc' => 'If True:</strong> Attributes that are out of stock will be displayed.<br>If False: Attributes that are out of stock will <em>not</em> be displayed.<br>Has no effect for sequenced dropdowns.<br>Default is True.',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_PI_QTPRO_OPTIONS_MARK_OUT_OF_STOCK' => [
          'title' => 'Mark Out of Stock Attributes',
          'value' => 'Right',
          'desc' => 'Controls how out of stock attributes are marked as out of stock.',
          'set_func' => "Config::select_one(['None', 'Right', 'Left'], ",
        ],
        'MODULE_CONTENT_PI_QTPRO_OPTIONS_OUT_OF_STOCK_MSGLINE' => [
          'title' => 'Display Out of Stock Message Line',
          'value' => 'True',
          'desc' => 'If True: If an out of stock attribute combination is selected by the customer, a message line informing on this will displayed.<br>Used for multiple dropdowns only.',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_PI_QTPRO_OPTIONS_NO_ADD_OUT_OF_STOCK' => [
          'title' => 'Prevent Adding Out of Stock to Cart',
          'value' => 'True',
          'desc' => 'If True: Customer will not be able to ad a product with an out of stock attribute combination to the cart. A javascript form will be displayed.',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_PI_QTPRO_OPTIONS_COMBINE_NON_STOCKED' => [
          'title' => 'Combine untracked options',
          'value' => 'True',
          'desc' => 'For single drop down or singel radio: combine also options which stock is not tracked.',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_PI_QTPRO_OPTIONS_ACTUAL_PRICE_PULL_DOWN' => [
          'title' => 'Use Actual Price Pull Downs',
          'value' => 'False',
          'desc' => 'NOTE: If you have more than one option per product, this can only be used with a satisfying result with single_dropdown or single_radioset.',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_PI_QTPRO_OPTIONS_SHOW_PLEASE_SELECT' => [
          'title' => 'Show default \'Please Select\' option',
          'value' => 'True',
          'desc' => 'If True: \'Please Select\' will be shown by default option. (multiple and single drop-down only)<br> If no other option is selected, click on \'Add to Cart\' button will show an alert.',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_PI_QTPRO_OPTIONS_SORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '80',
          'desc' => 'Sort order of display. Lowest is displayed first.',
        ],
      ];
    }

    function install($parameter_key = null) {
      parent::install($parameter_key);
      global $db;

// modify check stock hook pointer
      $db->query("UPDATE hooks
                    SET hooks_class = 'hook_shop_siteWide_qtPro',
                        hooks_method = 'listen_check_stock_qtpro'                        
                    WHERE hooks_site = 'shop'
                      AND hooks_group = 'checkout_payment_stage'
                      AND hooks_action = 'startCheckout'
                      AND hooks_code = '_09_check_stock'
                 ");

// modify update stock hook pointer
      $db->query("UPDATE hooks
                    SET hooks_class = 'hook_shop_siteWide_qtPro',
                        hooks_method = 'listen_update_stock_qtpro'                        
                    WHERE hooks_site = 'shop'
                      AND hooks_group = 'after'
                      AND hooks_action = 'afterStart'
                      AND hooks_code = '_21_update_stock'
                 ");

      // BEGIN options images support
      if ( file_exists(DIR_FS_CATALOG . 'includes/hooks/admin/products_attributes/OptImages.php')) {
        // ADD FIELD for options images
        if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_attributes' AND COLUMN_NAME LIKE 'option_image'")) != 1 ) {
          $db->query("AlTER TABLE products_attributes ADD option_image varchar(127) NULL default NULL");
        }
        // ADD FIELD for options sort order
        if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_attributes' AND COLUMN_NAME LIKE 'sort_order'")) != 1 ) {
        $db->query("ALTER TABLE products_attributes ADD sort_order int(11) NOT NULL default 0");
        }
        // ADD FIELD for options values images
        if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_options_values' AND COLUMN_NAME LIKE 'products_options_values_image'")) != 1 ) {
          $db->query("AlTER TABLE products_options_values ADD products_options_values_image varchar(127) NULL default NULL");
        }
        // Create image directory for options images
        if(!is_dir(DIR_FS_CATALOG . 'images/options/'))mkdir(DIR_FS_CATALOG . 'images/options/', 0755);
      }
      // END options images support

      // Add new column to products_options to indicate if stock should be tracked for an option
      if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='products_options' AND COLUMN_NAME LIKE 'products_options_track_stock'")) != 1 ) {
        $db->query("ALTER TABLE `products_options` ADD COLUMN `products_options_track_stock` TINYINT(4) DEFAULT '0' NOT NULL AFTER `products_options_name`");
      }
      // Add new column to orders_products to track attributes to make it possible to delete an order and restock
      if (mysqli_num_rows($db->query("SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_SCHEMA='". DB_DATABASE . "' AND TABLE_NAME='orders_products' AND COLUMN_NAME LIKE 'products_stock_attributes'")) != 1 ) {
        $db->query("ALTER TABLE `orders_products` ADD COLUMN `products_stock_attributes` VARCHAR(255) DEFAULT NULL AFTER `products_quantity`");
      }
      // Create new table to track stock for products attributes
      $db->query( "CREATE TABLE if not exists `products_stock` (`products_stock_id` INT(11) NOT NULL AUTO_INCREMENT,
                                                                  `products_id` INT(11) DEFAULT '0' NOT NULL ,
                                                                  `products_stock_attributes` VARCHAR(255) NOT NULL,
                                                                  `products_stock_quantity` INT(11) DEFAULT '0' NOT NULL ,
                                                                  PRIMARY KEY (products_stock_id),
                                                                  UNIQUE idx_products_stock_attributes (`products_id`,`products_stock_attributes`))");
      // Delete old configuration entries
      $db->query("DELETE FROM configuration_group WHERE configuration_group_title='Prod Info (QTPro)'");
      $db->query("DELETE FROM configuration WHERE configuration_key IN ('" . implode("', '", $this->old_keys()) . "')");
    }

    function remove($parameter_key = null) {
      parent::remove($parameter_key);
      global $db;

// restore check stock hook pointer
      $db->query("UPDATE hooks
                    SET hooks_class = 'checkout_surface',
                        hooks_method = 'check_stock'                        
                    WHERE hooks_site = 'shop'
                      AND hooks_group = 'checkout_payment_stage'
                      AND hooks_action = 'startCheckout'
                      AND hooks_code = '_09_check_stock'
                 ");

// restore update stock hook pointer
      $db->query("UPDATE hooks
                    SET hooks_class = 'Checkout',
                        hooks_method = 'update_stock'                        
                    WHERE hooks_site = 'shop'
                      AND hooks_group = 'after'
                      AND hooks_action = 'afterStart'
                      AND hooks_code = '_21_update_stock'
                 ");

      if ( defined('MODULE_CONTENT_PI_QTPRO_OPTIONS_REMOVE_DATA') && MODULE_CONTENT_PI_QTPRO_OPTIONS_REMOVE_DATA == 'True' ) {
      	$db->query("ALTER TABLE `products_options` DROP `products_options_track_stock`");
      	$db->query("ALTER TABLE `orders_products` DROP `products_stock_attributes`");
      	// BEGIN options images support
        $db->query("ALTER TABLE products_options_values DROP COLUMN IF EXISTS products_options_values_image");
        $db->query("ALTER TABLE `products_attributes` DROP COLUMN IF EXISTS `option_image`");
        // END options images support
      	$db->query("DROP TABLE IF EXISTS `products_stock`");
      }
    }

    function old_keys() {
      $KeysArray =  array('PRODINFO_ATTRIBUTE_PLUGIN',
                          'PRODINFO_ATTRIBUTE_SHOW_OUT_OF_STOCK',
                          'PRODINFO_ATTRIBUTE_MARK_OUT_OF_STOCK',
                          'PRODINFO_ATTRIBUTE_OUT_OF_STOCK_MSGLINE',
                          'PRODINFO_ATTRIBUTE_NO_ADD_OUT_OF_STOCK',
                          'PRODINFO_ATTRIBUTE_ACTUAL_PRICE_PULL_DOWN',
                          'PRODINFO_ATTRIBUTE_DISPLAY_STOCK_LIST');
      return $KeysArray;
    }

    public static function readonly($value) {
      return $value;
    }

  }

