<?php
/*
  QTpro
  Version 7.4.7 Phoenix

  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2021 Rainer Schmied

  CE Phoenix, E-Commerce made Easy
  https://phoenixcart.org

  Copyright (c) 2021 Phoenix Cart

  Released under the GNU General Public License
*/

class hook_shop_siteWide_qtPro {

  public $version = '7.4.6';

  function listen_check_stock_qtpro() {
    if ( STOCK_CHECK === 'true' ) {
      $any_out_of_stock = false;
      foreach ($_SESSION['cart']->get_products() as $product) {
        if ( $product->get('has_attributes') ) {
          if ($this->check_stock_qtpro($product)) {
            $any_out_of_stock = true;
          }
        } else {
          if ($product->lacks_stock()) {
            $any_out_of_stock = true;
          }
        }
      }

      // Out of Stock
      if ( $any_out_of_stock ) {
        Href::redirect($GLOBALS['Linker']->build('shopping_cart.php'));
      }
    }
  }

  function listen_update_stock_qtpro() {
    global $db;

    if (STOCK_LIMITED == 'true') {
// Stock Update - Joao Correia
      if (DOWNLOAD_ENABLED === 'true') {
        $stock_sql = <<<'EOSQL'
SELECT p.products_quantity, IF(pad.products_attributes_filename IS NULL, 1, 0) AS is_virtual
 FROM products p
   LEFT JOIN products_attributes pa ON p.products_id=pa.products_id
   LEFT JOIN products_attributes_download pad ON pa.products_attributes_id=pad.products_attributes_id
 WHERE p.products_id = %d
 ORDER BY pad.products_attributes_filename DESC
 LIMIT 1
EOSQL;
      } else {
        $stock_sql = "SELECT products_quantity FROM products WHERE products_id = %d";
      }

      foreach ($GLOBALS['order']->products as $product) {
        $attribute_array = [];
        $product_id = Product::build_prid($product['id']);
        if (($stock_values = $GLOBALS['db']->query(sprintf($stock_sql, (int)$product_id))->fetch_assoc()) && empty($stock_values['is_virtual'])) {
          $stock_left = $stock_values['products_quantity'] - $product['qty'];

          $sql_data = ['products_quantity' => (int)$stock_left];
          if ( ($stock_left < 1) && (STOCK_ALLOW_CHECKOUT == 'false') ) {
            $sql_data['products_status'] = '0';
          }
          $GLOBALS['db']->perform('products', $sql_data, 'update', 'products_id = ' . (int)$product_id);

          if ( empty($stock_values['is_virtual']) && !empty($product['attributes']) ) {
            $attributes_stock_array = $this->get_attributes_stock_qtpro($product_id);

            foreach ($product['attributes'] as $attribute) {
              $attribute_array[] = $attribute['option_id'] . '-' . $attribute['value_id'];
            }
            sort($attribute_array);
            $attribute_comb = implode(',', $attribute_array);

            if ( is_array($attributes_stock_array) && array_key_exists($attribute_comb, $attributes_stock_array) ) {

              $attributes_stock_left = $attributes_stock_array[$attribute_comb] - $product['qty'];
              $db->query(sprintf(<<<'EOSQL'
UPDATE products_stock
  SET products_stock_quantity = %s
  WHERE products_stock_attributes = '%s'
    AND products_id = %s
EOSQL
              , $attributes_stock_left, $attribute_comb, (int)$product_id));

            } else {
              $attributes_stock_left = 0 - $product['qty'];
              $db->query(sprintf(<<<'EOSQL'
INSERT INTO products_stock (products_id, products_stock_attributes, products_stock_quantity)
  VALUES (%s, '%s', %s)
EOSQL
              , (int)$product_id, $attribute_comb, $attributes_stock_left));

            }
          }
        }
      }
    }
  }

  function listen_injectSiteStart() {
    if ( Request::get_page() == 'product_info.php' && [] !== $GLOBALS['product']->get('attributes') ) {
      if ( defined('MODULE_CONTENT_PI_QTPRO_OPTIONS_STATUS') && MODULE_CONTENT_PI_QTPRO_OPTIONS_STATUS == 'True' ) {
        $class = 'pad_' . MODULE_CONTENT_PI_QTPRO_OPTIONS_PLUGIN;
      } elseif ( defined('PI_QTPRO_OPTIONS_STATUS') && PI_QTPRO_OPTIONS_STATUS == 'True' ) {
        $class = 'pad_' . PI_QTPRO_OPTIONS_PLUGIN;
      } else {
        $class = 'pad_base';
      }
      $GLOBALS['pad'] = new $class($GLOBALS['product']->get('id'));
    }
  }

  ////
  // Check if the required stock is available
  // If insufficent stock is available return $out_of_stock = true
  public function check_stock_qtpro($product) {
    return $this->get_products_stock_qtpro($product) < $product->get('quantity');
  }

  ////
  // Return a product's stock
  // TABLES: products. products_stock
  private function get_products_stock_qtpro($product) {

    $products_id = $product->get('id');
    $attributes_selection = $product->get('attribute_selections');
    ksort($attributes_selection);
    $attributes = $product->get('attributes');
    $all_nonstocked = true;

    if (sizeof($attributes_selection) > 0) {
      $attr_list = '';
      foreach ($attributes_selection as $option_id => $attribute_id) {
        if ( $attributes[$option_id]['track_stock'] == true) {
          $attr_list .= $option_id . '-' . $attribute_id . ',';
          $all_nonstocked = false;
        }
      }
      $attr_list = substr($attr_list, 0, strlen($attr_list)-1);
    }

    if ( (sizeof($attributes_selection) == 0) || ($all_nonstocked) ) {
      $stock = $product->get('quantity');
    } else {
      $attributes_stock_array = $this->get_attributes_stock_qtpro($products_id);
      $stock = $attributes_stock_array[$attr_list]?? 0;
    }
    return $stock ?? 0;
  }

  ////
  // retrieve the attributes stock for a product
  //
  public function get_attributes_stock_qtpro($products_id) {
    $products_stock_query = $GLOBALS['db']->query(sprintf(<<<'EOSQL'
SELECT products_stock_attributes, products_stock_quantity
  FROM products_stock
  WHERE products_id = %s
  ORDER BY products_stock_attributes
EOSQL
      , (int)$products_id));

    if (mysqli_num_rows($products_stock_query)) {
      while ( $products_stock = $products_stock_query->fetch_assoc() ) {
        $products_attrib_comb_stock[$products_stock['products_stock_attributes']] =  $products_stock['products_stock_quantity'];
      }
      return $products_attrib_comb_stock;
    }
  }
}
